# Copyright (C) 1997, 1998 T. Douglas Mast (see the file LICENSE for terms)

global hexpath
set hexpath $ichingpath/hexagrams
source $ichingpath/randutil.tcl

proc randomint {start stop}  {
	expr [randomRange [expr $stop - $start + 1]] + $start  
}

proc primhex {} {
   global hexdig
   set hexdig [throw]
   set hexnumber [hexnum $hexdig]
   append primout "\nPrimary Hexagram:\n\n"
   append primout "[writehex $hexdig]\n"
   append primout "[gettext $hexnumber]\n"
   return $primout
}

proc sechex {} {
   global hexdig
   set sechexdig [agelines $hexdig]
   if {[lindex $sechexdig 6] > 0} {
     append secout "Secondary Hexagram:\n\n"
     append secout "[writehex $sechexdig]\n"
     set hexnumber "[hexnum $sechexdig]" 
     append secout "[gettext $hexnumber]\n"
     return $secout
     }
 }

proc throw {} {

# generate hexagram data using coin method

for {set line 1} {$line <= 6} {incr line 1} {
   set linetotal 0
   for {set coin 1} {$coin <= 3} {incr coin 1} {
      incr linetotal [randomint 2 3]
     }
    lappend hexlist $linetotal
   } 

   return $hexlist
}

proc gettext {hexnum} {
   global hexpath 
   set fid [open $hexpath/hexagram.$hexnum] 
   set textout [read $fid]
   return $textout
}

proc writehex {hexdig} {
    for {set i 6} {$i > 0} {incr i -1} {
      append hexasc "   $i  ---"
      set linval [lindex $hexdig [expr $i-1]]

# constructs string representation of hexagram picture from coin data,
# starting (as it should :-) with the first line at the bottom

# 6: old yin (divided, changing)
# 7: young yang (undivided)
# 8: young yin (divided)
# 9: old yang (undivided, changing)

      switch -exact -- $linval {
    	 6 {append hexasc x }
         7 {append hexasc - }
         8 {append hexasc \ }
         9 {append hexasc o }
      }
      append hexasc ---\n
    }
    return $hexasc
}

proc agelines {hexdig} {

    set chflag 0
    for {set i 0} {$i < 6} {incr i 1} {
	    set linval [lindex $hexdig $i]
#       puts stdout $linval
        switch -exact -- $linval {
	   6 {lappend hexlist 7; incr chflag 1}
	   7 {lappend hexlist 7}
	   8 {lappend hexlist 8}
	   9 {lappend hexlist 8; incr chflag 1}
       }
       }
       lappend hexlist $chflag
       return $hexlist
}

proc hexnum {hexdig} {

    set hexno 0
    for {set i 0} {$i < 6} {incr i 1} {
      set linval [lindex $hexdig $i]

# calculate integer from binary code: 1 for undivided, 0 for divided

      switch -exact -- $linval {
	 6 {set bit 0}
         7 {set bit 1}
         8 {set bit 0}
         9 {set bit 1}
      }

# binary moduli for each line place (1 = bottom, 32 = top)

      switch -exact -- $i {
          0 {set hexmod 32}
	  1 {set hexmod 16}
	  2 {set hexmod 8}
	  3 {set hexmod 4}
	  4 {set hexmod 2}
	  5 {set hexmod 1}
      }    
      set hexinc [expr $hexmod * $bit]	  
      incr hexno $hexinc
    }

# big, ugly lookup table for King Wan's order

    switch -exact -- $hexno {
	0  {set hexyes 2}
	1  {set hexyes 23}
	2  {set hexyes 8}
	3  {set hexyes 20}
	4  {set hexyes 16}
	5  {set hexyes 35}
	6  {set hexyes 45}
	7  {set hexyes 12}
	8  {set hexyes 15}
	9  {set hexyes 52}
	10 {set hexyes 39}
	11 {set hexyes 53}
	12 {set hexyes 62}
	13 {set hexyes 56}
	14 {set hexyes 31}
	15 {set hexyes 33}
	16 {set hexyes 7}
	17 {set hexyes 4}
	18 {set hexyes 29}
	19 {set hexyes 59}
	20 {set hexyes 40}
	21 {set hexyes 64}
	22 {set hexyes 47}
	23 {set hexyes 6}
	24 {set hexyes 46}
	25 {set hexyes 18}
	26 {set hexyes 48}
	27 {set hexyes 57}
	28 {set hexyes 32}
	29 {set hexyes 50}
	30 {set hexyes 28}
	31 {set hexyes 44}
	32 {set hexyes 24}
	33 {set hexyes 27}
	34 {set hexyes 3}
	35 {set hexyes 42}
	36 {set hexyes 51}
	37 {set hexyes 21}
	38 {set hexyes 17}
	39 {set hexyes 25}
	40 {set hexyes 36}
	41 {set hexyes 22}
	42 {set hexyes 63}
	43 {set hexyes 37}
	44 {set hexyes 55}
	45 {set hexyes 30}
	46 {set hexyes 49}
	47 {set hexyes 13}
	48 {set hexyes 19}
	49 {set hexyes 41}
	50 {set hexyes 60}
	51 {set hexyes 61}
	52 {set hexyes 54}
	53 {set hexyes 38}
	54 {set hexyes 58}
	55 {set hexyes 10}
	56 {set hexyes 11}
	57 {set hexyes 26}
	58 {set hexyes 5}
	59 {set hexyes 9}
	60 {set hexyes 34}
        61 {set hexyes 14}
	62 {set hexyes 43}
	63 {set hexyes 1}
    }
    return $hexyes
}











